"use strict";
exports.__esModule = true;
// Context API Dev Tools
var devTools = { send: function () { } };
var isInitialized = false;
var firstRender = false;
var oldArgs = {};
var useContextDevTools = function (dispatch) {
    if (!isInitialized) {
        devTools.current = window.__REDUX_DEVTOOLS_EXTENSION__.connect();
        isInitialized = true;
    }
    var sendDispatch = function (args) {
        if (dispatch) {
            dispatch(args);
        }
        oldArgs = args;
    };
    var sendUpdatedState = function (updatedState) {
        if (!firstRender) {
            devTools.current.init(updatedState);
            firstRender = true;
        }
        else {
            devTools.current.send(oldArgs, { root: updatedState });
        }
    };
    var disconnectDevTools = function () {
        return devTools.current.disconnect();
    };
    return {
        sendDispatch: sendDispatch,
        sendUpdatedState: sendUpdatedState,
        disconnectDevTools: disconnectDevTools
    };
};
exports["default"] = useContextDevTools;
